; File Name   :		czepa\c-80.bin
; Format      :		Binary File
; Base Address:		0000h Range: 0000h - 0400h Loaded length: 0400h

		cpu 	z80
		org	0

; Monitorstart mit Anzeige Dezimalpunkt	(RST0)

sub_0:		ld	sp, 0FD7h
		ld	a, 80h ; ''
		jp	loc_A1

; UP: Tastatureingabe mit Anzeige DISPLAY-RAM (RST8)
; nach RET : A = Tastenkode
; verndert : AF, DE', BC', HL'

sub_8:		exx
		ld	e, 0
		jp	loc_28C
		db    0	;
		db    0	;


; UP: Ausgabe ADR in DISPLAY-RAM (Stelle 1-4) (RST 10)
; vor CALL : HL	= ADRESSE
; verndert : AF, DE', HL', IY

sub_10:		ld	iy, 0FF3h
		ld	a, h
		jp	loc_26B

; UP: Eingabe einer Adresse mit	Anzeige	(RST18)
; nach RET : HL	= ADRESSE
; verndert : AF, BC', DE', HL', IY

sub_18:		sub	a
sub_19:		ld	h, 0
		jp	loc_260
		db    0	;
		db    0	;

; UP: Lschen DISPLAY-RAM	(RST20)
; verndert: F,	B, HL

sub_20:		ld	hl, 0FF3h
		ld	b, 9
		jp	loc_85

; UP: Eingabe Anfangs- und Endadresse eines (RST28)
; Speicherbereiches mit	Anzeige
; vor Call : A = Anzeigekode fr Stelle	6
; nach RET : DE	= AADR,	HL = Byteanzahl
; verndert : AF, BC, BC', DE', HL', IY

sub_28:		ld	bc, 0FF8h
		ld	(bc), a
		inc	bc
		jp	loc_8B

; UP: Ausgabe BYTE in DISPLAY-RAM (St. 6,7) (RST30)
; vor CALL : C = BYTE
; verndert : AF, DE', HL', IY

sub_30:		ld	iy, 0FF8h
		ld	a, c
		jp	sub_26F

; Haltepunkt- und NMI-Behandlung
		ld	(0FEFh), sp
		ld	sp, 0FEDh
		push	af
		push	bc
		push	de
		push	hl
		ex	af, af'
		exx
		push	af
		push	bc
		push	de
		push	hl
		ld	a, i
		ld	b, a
		ld	c, 0
		jp	po, loc_52
		inc	c
loc_52:		push	bc
		push	ix
		push	iy
		ld	sp, (0FEFh)
		pop	de
		ld	(0FEFh), sp
		ld	hl, (0FF1h)
		ld	a, h
		or	l
		ld	bc, 0D018h
		ld	sp, 0FD7h
		jr	z, loc_7D
		dec	de
		push	hl
		sbc	hl, de
		jr	z, loc_74
		inc	de
loc_74:		pop	hl
		ld	a, (hl)
		inc	a
		jr	nz, loc_7D
		ld	a, (0FFEh)
		ld	(hl), a
loc_7D:		ex	de, hl
		ld	(0FEDh), hl
		ld	a, 14h
		jr	loc_A6

; Fortsetzung RST 20H

loc_85:		ld	(hl), 0
		inc	hl
		djnz	loc_85
		ret

; Fortsetzung RST 28H

loc_8B:		ld	a, 77h ; 'w'
		ld	(bc), a
		rst	18h
		cp	11h
		jr	nz, loc_A6
		push	hl
		ld	a, 79h ; 'y'
		ld	(bc), a
		rst	18h
		jr	nz, loc_A6
		pop	de
		sbc	hl, de
		inc	hl
		ret	nc
		ld	a, 79h ; 'y'

; Fortsetzung RST 0

loc_A1:		rst	20h
		ld	(0FF3h), a
		rst	8
loc_A6:		ld	sp, 0FD7h
		rst	20h
		ld	hl, 0A6h ; ''
		push	hl
		sub	13h
		jr	z, loc_11F
		dec	a
		jp	z, loc_17A
		dec	a
		jr	z, loc_DE
		sub	0Bh
		jr	z, loc_F7
		dec	a
		jp	z, loc_1E6
		ld	bc, 0FF38h
		dec	a
loc_C5:		jp	z, loc_20A
		ld	bc, 73h	; 's'
		dec	a
		jr	z, loc_C5
		dec	a
		jp	z, loc_1C6
		dec	a
		jr	z, loc_114
		dec	a
		jr	z, loc_107
		cp	0Ah
		jp	c, 400h
		rst	0

; Monitorfunktion MEM

loc_DE:		rst	18h
		ret	nz
loc_E0:		ld	a, 23h ; '#'
loc_E2:		ld	a, 2Bh ; '+'
loc_E4:		ld	c, (hl)
		rst	30h
		rst	10h
		rst	8
		jr	z, loc_E0+1
		cp	11h
		jr	z, loc_E2+1
		ret	nc
		call	sub_251
		jr	nz, loc_E4
		ld	(hl), c
		jr	loc_E0+1

; Monitorfunktion FILL

loc_F7:		ld	a, 71h ; 'q'
		rst	28h
		call	sub_250
		ret	nz
		ex	de, hl
loc_FF:		ld	(hl), c
		dec	de
		inc	hl
		ld	a, d
		or	e
		jr	nz, loc_FF
		rst	0

; Monitorfunktion OUT

loc_107:	rst	18h
		ret	nz
loc_109:	call	sub_250
		ret	nz
		ld	b, h
		ld	a, c
		ld	c, l
		out	(c), a
		jr	loc_109

; Monitorfunktion IN

loc_114:	rst	18h
		ret	nz
loc_116:	ld	b, h
		ld	c, l
		in	c, (c)
		rst	30h
		rst	8
		jr	z, loc_116
		ret

; Monitorfunktion GO

loc_11F:	ld	hl, (0FEDh)
		rst	10h
		rst	8
		jr	nc, loc_12F
		ld	hl, 0FC0h
		ld	(0FEFh), hl
		call	sub_19
loc_12F:	ld	(0FFCh), hl
		ld	hl, 0
		jr	z, loc_147
		cp	11h
		ret	nz
		ld	a, 76h ; 'v'
		ld	(0FF9h), a
		rst	18h
		ret	nz
		ld	a, (hl)
		ld	(0FFEh), a
		ld	(hl), 0FFh
loc_147:	ld	(0FF1h), hl
		pop	af
		ld	hl, 0C3FFh
		ld	(0FFAh), hl
		pop	iy
		pop	ix
		pop	af
		ld	i, a
		ld	hl, 0D3FBh
		jr	c, loc_15F
		ld	l, 0F3h	; ''
loc_15F:	ld	(0FF8h), hl
		pop	hl
		pop	de
		pop	bc
		pop	af
		ex	af, af'
		exx
		pop	hl
		pop	de
		pop	bc
		pop	af
		ld	sp, (0FEFh)
		jp	0FF8h

; Monitorfunktion REG

loc_173:	rst	8
		ret	nc
		ld	(hl), a
		db  0Eh		; ignore next code (?)
loc_177:	inc	(hl) 
		db  3Eh		; ignore next code (?)
loc_179:	dec	(hl)
loc_17A:	call	sub_1AE
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		rst	10h
		ld	hl, unk_3E6
		add	hl, de
		ld	de, 0FF8h
		ldi
		ldi
		ld	hl, 0FFFh
		rst	8
		jr	z, loc_177
		cp	14h
		jr	z, loc_173
		cp	11h
		jr	z, loc_179
		ret	nc
		ld	c, a
		call	sub_1AE
		call	sub_252
		inc	hl
		jr	z, loc_1AB
		cp	11h
		jr	nz, loc_17A
		dec	hl
loc_1AB:	ld	(hl), c
		jr	loc_17A

sub_1AE:	ld	hl, 0FFFh
		ld	a, (hl)
		cp	0Dh
		jr	c, loc_1BB
		jr	nz, loc_1B9
		xor	a
loc_1B9:	and	0Ch
loc_1BB:	ld	(hl), a
		add	a, a
		ld	hl, 0FEFh
		ld	e, a
		xor	a
		ld	d, a
		sbc	hl, de
		ret

; Monitorfunktion MOVE

loc_1C6:	ld	a, 5Ch ; '\'
		rst	28h
		ld	a, 77h ; 'w'
		ld	(bc), a
		dec	bc
		ld	a, 54h ; 'T'
		ld	(bc), a
		ld	b, h
		ld	c, l
		rst	18h
		ret	nz
		push	hl
		sbc	hl, de
		pop	hl
		jr	c, loc_1E2
		dec	bc
		add	hl, bc
		ex	de, hl
		add	hl, bc
		inc	bc
		lddr
		rst	0
loc_1E2:	ex	de, hl
		ldir
		rst	0

; Monitorfunktion SAVE

loc_1E6:	ld	a, 6Dh ; 'm'
		rst	28h
		push	de
		ld	bc, 20h	; ' '
		exx
		pop	hl
		ld	bc, 7D0h
loc_1F2:	ld	de, 0
		call	sub_2F4
		exx
		scf
		sbc	hl, bc
		inc	hl
		exx
		ld	bc, 0Eh
		jr	nc, loc_1F2
		ld	de, 0FFFFh
		call	sub_2F4
		rst	0

; Monitorfunktion LOAD und LOADP

loc_20A:	push	bc
		ld	a, c
		rst	28h
		pop	bc
		ld	c, 0
		ld	a, b
		exx
loc_212:	ld	hl, 0FD7h
		push	hl
		call	sub_34F
		pop	hl
		ld	c, a
		ld	b, 20h ; ' '
		ld	a, d
		exx
		jr	nz, loc_225+1
		and	b
		jp	m, loc_242
loc_225:	call	m, 0D50Ch
		bit	4, c
		jr	nz, loc_245
		ld	a, b
		exx
loc_22E:	and	c
		ld	a, (hl)
		inc	hl
		exx
		jr	nz, loc_235
		ld	(de), a
loc_235:	inc	de
		dec	hl
		ld	a, h
		or	l
		jr	z, loc_243
		ld	a, b
		exx
		djnz	loc_22E
		sub	a
		jr	loc_212
loc_242:	xor	a
loc_243:	or	c
		ret	z
loc_245:	pop	hl
		rst	10h
		rst	30h
		rst	8
		jp	nz, loc_A6
		dec	c
		jr	nz, loc_245
		rst	0


; UP: Eingabe eines Bytes mit Anzeige
; nach RET : C = BYTE
; verndert : AF, BC', DE', HL', IY

sub_250:	sub	a
sub_251:	ld	c, a
sub_252:	rst	30h
		rst	8
		ret	nc
		sla	c
		sla	c
		sla	c
		sla	c
		add	a, c
		jr	sub_251

; Fortsetzung RST 18H

loc_260:	ld	l, a
		rst	10h
		rst	8
		ret	nc
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	a, l
		jr	loc_260

; Fortsetzung RST 10H

loc_26B:	call	sub_26F
		ld	a, l

; Fortsetzung RST 30H

sub_26F:	push	af
		rlca
		rlca
		rlca
		rlca
		call	sub_278
		pop	af

; UP: Umkodierung HEX in 7-Segment-Kode mit Ausgabe in DISPLAY-RAM
; vor CALL : A=	HEX-ZIFFER (BIT	3...0)
;	     IY	= Adresse DISPLAY-RAM
; nach RET : IY	= ADR+ 1, (IY+0) = 7-Segment-Kode
; verndert : AF, DE', HL', IY

sub_278:	exx
		ld	hl, unk_3D6
		and	0Fh
		ld	e, a
		ld	d, 0
		add	hl, de
		ld	a, (hl)
		exx
		ld	(iy+0),	a
		inc	iy
		ret

; Fortsetzung RST 8H

loc_28A:	ld	e, 20h ; ' '
loc_28C:	ld	d, 0FFh
loc_28E:	ld	b, 3		; Speicherzelle	fr Entprellzeit-Konstante (N*8ms)
loc_290:	ld	hl, 0FF3h
		call	sub_2C9
		xor	d
		rlca
		jr	nc, loc_28E
		djnz	loc_290
		inc	d
		jr	z, loc_28E
		ld	hl, locret_3BD
		ld	bc, 0FEBDh
loc_2A5:	out	(c), b
		inc	hl
		in	a, (0BCh)
		cpl
		and	7
		jr	nz, loc_2B5
		rlc	b
		jr	c, loc_2A5
		jr	loc_28C
loc_2B5:	ld	b, 0
		out	(c), b
		rra
		rlca
		rlca
		rlca
		ld	c, a
		add	hl, bc
		ld	a, (hl)
		add	a, e
		cp	12h
		jr	z, loc_28A
		exx
		cp	10h
		ret

; UP: Einmalige	Ausgabe	DISPLAY-RAM ber PIO 1 (UP enthlt PIO - Programmierung)
; vor CALL : HL	= Anfangsadresse DISPLAY-RAM
; nach RET : A 0, wenn keine Taste gedrckt verndert :	AF, HL

sub_2C9:	ld	a, 0FFh
		out	(0BEh),	a
		ld	a, 9Fh ; ''
		out	(0BEh),	a
		ld	a, 0Fh
		out	(0BFh),	a
		in	a, (0BCh)
		res	5, a
		out	(0BCh),	a
		push	bc
		ld	bc, 9BDh
loc_2DF:	in	a, (0BCh)
		bit	4, a
		jr	z, loc_2DF
		outi
		jr	nz, loc_2DF
		in	a, (0BCh)
		set	5, a
		out	(0BCh),	a
		or	0F8h ; ''
		inc	a
		pop	bc
		ret

; UP: Ausgabe eines Datenblocks	auf Kassette
; vor CALL : BC	= Anzahl der SYNC-Bits
;	     DE	= Kennwort des Blocks
;	     HL	= Anfangsadresse im Speicher
; nach RET : HL	= ADR +	32
; verndert : AF, AF', BC, DE, HL, IX

sub_2F4:	ld	a, 2Ah ; '*'
loc_2F6:	dec	a
		jr	nz, loc_2F6
		call	sub_348
		dec	bc
		ld	a, b
		or	c
		jr	nz, sub_2F4
		call	sub_344
		push	de
		pop	ix
		call	sub_344
		ld	b, 7
		call	sub_328
		ld	a, 10h
		ld	b, 2
loc_313:	ex	af, af'
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		inc	hl
		add	ix, de
		call	sub_328
		ex	af, af'
		dec	a
		ld	b, 1
		jr	nz, loc_313
		push	ix
		pop	de
		ld	b, 4
sub_328:	ld	c, 10h
loc_32A:	djnz	$
		srl	d
		rr	e
		ccf
		rra
		rra
		ld	b, a
		in	a, (0BCh)
		xor	b
		out	(0BCh),	a
		ld	b, 0Bh
		call	sub_346
		dec	c
		ret	z
		ld	b, 8
		jr	loc_32A
sub_344:	ld	b, 17h
sub_346:	djnz	$
sub_348:	in	a, (0BCh)
		xor	40h ; '@'
		out	(0BCh),	a
		ret

; UP: Lesen eines Datenblocks von Kassette
; vor CALL : A=0FFH, Synchronisation nur bei Datenblcken, sonst A = 0
;	     HL	= Anfangsadresse im Speicher
; nach RET : A = 0, wenn kein Lesefehler
;	     DE	= gelesenes. Kennwort
;	     HL	= ADR +	32
; verndert : AF, AF', BC, DE, HL, IX

sub_34F:	ex	af, af'
loc_350:	ld	b, 7
loc_352:	in	a, (0BCh)
		ld	c, a
		ld	d, 19h
loc_357:	dec	d
		jr	z, loc_350
		in	a, (0BCh)
		xor	c
		jp	p, loc_357
		ld	a, d
		cp	0Dh
		jr	nc, loc_350
		djnz	loc_352
loc_367:	ld	b, 25h ; '%'
		call	sub_3AE
		jp	m, loc_367
		ld	b, 0Dh
		call	sub_39E
		ex	af, af'
		and	d
		jp	m, sub_34F
		push	de
		push	de
		pop	ix
		ld	a, 10h
loc_37F:	ex	af, af'
		call	sub_39C
		add	ix, de
		ld	(hl), e
		inc	hl
		ld	(hl), d
		inc	hl
		ex	af, af'
		dec	a
		jr	nz, loc_37F
		ld	a, (hl)
		call	sub_39C
		push	ix
		ex	(sp), hl
		xor	a
		sbc	hl, de
		or	h
		or	l
		pop	hl
		pop	de
		ret

sub_39C:	ld	b, 8
sub_39E:	ld	de, 8000h
loc_3A1:	call	sub_3AE
		rla
		rr	d
		rr	e
		ret	c
		ld	b, 0Eh
		jr	loc_3A1
sub_3AE:	djnz	$
		in	a, (0BCh)
		ld	b, a
		xor	c
		ld	c, b
		push	af
loc_3B6:	in	a, (0BCh)
		xor	c
		jp	p, loc_3B6
		pop	af
locret_3BD:	ret

; Tastaturcodetabelle

		db  14h	;
		db  13h	;
		db  0Dh	;
		db  0Ah	;
		db    7	;
		db    4	;
		db    1	;
		db  12h	;
		db  10h	;
		db  11h	;
		db  0Eh	;
		db  0Bh	;
		db    8	;
		db    5	;
		db    2	;
		db    0	;
		db 0FFh	;
		db 0FFh	;
		db  0Fh	;
		db  0Ch	;
		db    9	;
		db    6	;
		db    3	;
		db  15h	;

; 7-Segment-Kode-Tabelle

unk_3D6:	db  3Fh	; ?
		db    6	;
		db  5Bh	; [
		db  4Fh	; O
		db  66h	; f
		db  6Dh	; m
		db  7Dh	; }
		db    7	;
		db  7Fh	; 
		db  6Fh	; o
		db  77h	; w
		db  7Ch	; |
		db  39h	; 9
		db  5Eh	; ^
		db  79h	; y
		db  71h	; q

; Registernamen

unk_3E6:	db  6Dh	; m
		db  73h	; s
		db  73h	; s
		db  39h	; 9
		db  77h	; w
		db  71h	; q
		db  7Ch	; |
		db  39h	; 9
		db  5Eh	; ^
		db  79h	; y
		db  76h	; v
		db  38h	; 8
		db  77h	; w
		db 0F1h	; 
		db  7Ch	; |
		db 0B9h	; 
		db  5Eh	; ^
		db 0F9h	; 
		db  76h	; v
		db 0B8h	; 
		db    6	;
		db  71h	; q
		db    6	;
		db  76h	; v
		db    6	;
		db  72h	; r
; end of 'ROM'

		end
